'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StaleElementReferenceError = require('selenium-webdriver').error.StaleElementReferenceError;

var AxeInjector = function () {
  function AxeInjector(_ref) {
    var driver = _ref.driver,
        config = _ref.config,
        _ref$axeSource = _ref.axeSource,
        axeSource = _ref$axeSource === undefined ? null : _ref$axeSource,
        _ref$options = _ref.options,
        options = _ref$options === undefined ? {} : _ref$options;

    _classCallCheck(this, AxeInjector);

    this.driver = driver;
    this.axeSource = axeSource || require('axe-core').source;
    this.config = config ? JSON.stringify(config) : '';
    this.options = options;

    // default is set to true so it does not rewrite iframes in the DOM
    // validates the value being passed to sandbox as a boolean
    this.options.noSandbox = typeof this.options.noSandbox === 'boolean' ? this.options.noSandbox : false;

    // default logIframeErrors to true so it retains the original behavior
    this.options.logIframeErrors = typeof this.options.logIframeErrors === 'boolean' ? this.options.logIframeErrors : true;

    this.didLogError = false;
    this.errorHandler = this.errorHandler.bind(this);
  }

  // Single-shot error handler. Ensures we don't log more than once.


  _createClass(AxeInjector, [{
    key: 'errorHandler',
    value: function errorHandler(err) {
      // We've already "warned" the user. No need to do it again (mostly for backwards compatiability)
      if (this.didLogError) {
        return;
      }

      this.didLogError = true;
      var msg = void 0;
      if (err instanceof StaleElementReferenceError) {
        msg = 'Tried to inject into a removed iframe. This will not affect the analysis of the rest of the page but you might want to ensure the page has finished updating before starting the analysis.';
      } else {
        msg = 'Failed to inject axe-core into one of the iframes!';
      }

      if (this.options.logIframeErrors) {
        // eslint-disable-next-line no-console
        console.error(msg);
        return;
      }

      throw new Error(msg);
    }

    // Get axe-core source (and configuration)

  }, {
    key: 'handleFrame',


    // Inject into the provided `frame` and its child `frames`
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(framePath) {
        var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, frame, frames, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, childFrame;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.driver.switchTo().defaultContent();

              case 2:
                // Switch context to the frame and inject our `script` into it
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 5;
                _iterator = framePath[Symbol.iterator]();

              case 7:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 14;
                  break;
                }

                frame = _step.value;
                _context.next = 11;
                return this.driver.switchTo().frame(frame);

              case 11:
                _iteratorNormalCompletion = true;
                _context.next = 7;
                break;

              case 14:
                _context.next = 20;
                break;

              case 16:
                _context.prev = 16;
                _context.t0 = _context['catch'](5);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 20:
                _context.prev = 20;
                _context.prev = 21;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 23:
                _context.prev = 23;

                if (!_didIteratorError) {
                  _context.next = 26;
                  break;
                }

                throw _iteratorError;

              case 26:
                return _context.finish(23);

              case 27:
                return _context.finish(20);

              case 28:
                if (!this.options.noSandbox) {
                  _context.next = 31;
                  break;
                }

                _context.next = 31;
                return this.sandboxBuster();

              case 31:
                _context.next = 33;
                return this.driver.executeScript(this.script);

              case 33:
                _context.next = 35;
                return this.driver.findElements({ tagName: 'iframe' });

              case 35:
                frames = _context.sent;


                // Inject into each frame. Handling errors to ensure an issue on a single frame won't stop the rest of the injections.
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context.prev = 39;
                _iterator2 = frames[Symbol.iterator]();

              case 41:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context.next = 58;
                  break;
                }

                childFrame = _step2.value;

                framePath.push(childFrame);
                _context.prev = 44;
                _context.next = 47;
                return this.handleFrame(framePath);

              case 47:
                _context.next = 52;
                break;

              case 49:
                _context.prev = 49;
                _context.t1 = _context['catch'](44);

                this.errorHandler(_context.t1);

              case 52:
                _context.prev = 52;

                framePath.pop();
                return _context.finish(52);

              case 55:
                _iteratorNormalCompletion2 = true;
                _context.next = 41;
                break;

              case 58:
                _context.next = 64;
                break;

              case 60:
                _context.prev = 60;
                _context.t2 = _context['catch'](39);
                _didIteratorError2 = true;
                _iteratorError2 = _context.t2;

              case 64:
                _context.prev = 64;
                _context.prev = 65;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 67:
                _context.prev = 67;

                if (!_didIteratorError2) {
                  _context.next = 70;
                  break;
                }

                throw _iteratorError2;

              case 70:
                return _context.finish(67);

              case 71:
                return _context.finish(64);

              case 72:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[5, 16, 20, 28], [21,, 23, 27], [39, 60, 64, 72], [44, 49, 52, 55], [65,, 67, 71]]);
      }));

      function handleFrame(_x) {
        return _ref2.apply(this, arguments);
      }

      return handleFrame;
    }()
  }, {
    key: 'sandboxBuster',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var _this = this;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', new Promise(function (resolve, reject) {
                  /* eslint-disable no-undef */
                  _this.driver.executeAsyncScript(function (callback) {
                    var iframes = Array.from(document.querySelectorAll('iframe[sandbox]'));
                    var removeSandboxAttr = function removeSandboxAttr(clone) {
                      return function (attr) {
                        if (attr.name === 'sandbox') return;
                        clone.setAttribute(attr.name, attr.value);
                      };
                    };
                    var replaceSandboxedIframe = function replaceSandboxedIframe(iframe) {
                      var clone = document.createElement('iframe');
                      var promise = new Promise(function (iframeLoaded) {
                        return clone.onload = iframeLoaded;
                      });
                      Array.from(iframe.attributes).forEach(removeSandboxAttr(clone));
                      iframe.parentElement.replaceChild(clone, iframe);
                      return promise;
                    };
                    Promise.all(iframes.map(replaceSandboxedIframe)).then(callback);
                  })
                  /* eslint-enable no-undef */
                  // resolve the outer promise
                  .then(resolve).catch(function (e) {
                    return reject(e);
                  });
                }));

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function sandboxBuster() {
        return _ref3.apply(this, arguments);
      }

      return sandboxBuster;
    }()
    // Inject into all frames.

  }, {
    key: 'injectIntoAllFrames',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var frames, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, childFrame;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.driver.switchTo().defaultContent();

              case 2:
                if (!this.options.noSandbox) {
                  _context3.next = 5;
                  break;
                }

                _context3.next = 5;
                return this.sandboxBuster();

              case 5:
                _context3.next = 7;
                return this.driver.executeScript(this.script);

              case 7:
                _context3.next = 9;
                return this.driver.findElements({ tagName: 'iframe' });

              case 9:
                frames = _context3.sent;


                // Inject the script into all child frames. Handle errors to ensure we don't stop execution if we fail to inject.
                _iteratorNormalCompletion3 = true;
                _didIteratorError3 = false;
                _iteratorError3 = undefined;
                _context3.prev = 13;
                _iterator3 = frames[Symbol.iterator]();

              case 15:
                if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                  _context3.next = 28;
                  break;
                }

                childFrame = _step3.value;
                _context3.prev = 17;
                _context3.next = 20;
                return this.handleFrame([childFrame]);

              case 20:
                _context3.next = 25;
                break;

              case 22:
                _context3.prev = 22;
                _context3.t0 = _context3['catch'](17);

                this.errorHandler(_context3.t0);

              case 25:
                _iteratorNormalCompletion3 = true;
                _context3.next = 15;
                break;

              case 28:
                _context3.next = 34;
                break;

              case 30:
                _context3.prev = 30;
                _context3.t1 = _context3['catch'](13);
                _didIteratorError3 = true;
                _iteratorError3 = _context3.t1;

              case 34:
                _context3.prev = 34;
                _context3.prev = 35;

                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }

              case 37:
                _context3.prev = 37;

                if (!_didIteratorError3) {
                  _context3.next = 40;
                  break;
                }

                throw _iteratorError3;

              case 40:
                return _context3.finish(37);

              case 41:
                return _context3.finish(34);

              case 42:
                return _context3.abrupt('return', this.driver.switchTo().defaultContent());

              case 43:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[13, 30, 34, 42], [17, 22], [35,, 37, 41]]);
      }));

      function injectIntoAllFrames() {
        return _ref4.apply(this, arguments);
      }

      return injectIntoAllFrames;
    }()

    // Inject axe, invoking the provided callback when done

  }, {
    key: 'inject',
    value: function inject(callback) {
      var _this2 = this;

      this.injectIntoAllFrames().then(function () {
        return callback();
      }).catch(function (e) {
        if (_this2.options.logIframeErrors) {
          return callback();
        }

        callback(e);
      });
    }
  }, {
    key: 'script',
    get: function get() {
      return `
      ${this.axeSource}
      ${this.config ? `axe.configure(${this.config})` : ''}
      axe.configure({ branding: { application: 'webdriverjs' } })
    `;
    }
  }]);

  return AxeInjector;
}();

module.exports = AxeInjector;